image: docker:latest
services:
  - name: docker:dind
    alias: docker-vm

stages:
  - Build
  - Test acceptation
  - Release image
  - Deploy review #est inséré à la fin du script, mais exécuté dans l'ordre déclaré dans le 'stages'
  - Stop review #ajout du stop review pour la suppression de l'environnemnt de review une fois le merge vers le main effectif
  - Deploy staging 
  - Deploy prod  

docker-build: # Création d'un nouveau job.
  # Use the official docker image.
  stage: Build
  #tags:
    #- carlinfg # tag  du runner privé local
  script:
    - docker build -t  lab2-alpinehelloworld .
    - docker save lab2-alpinehelloworld > lab2-alpinehelloworld.tar # Génération de l'artifact à utiliser pour le test d'acceptation
  artifacts:
    paths:
      - lab2-alpinehelloworld.tar   # Sauvegarde de l'artifact pour usage dans le job suivant 

test acceptation:
  # Official docker image.
  stage: Test acceptation
  #tags:
    #- carlinfg
  script:
    - docker rmi -f lab2-alpinehelloworld || echo "image already deleted"  #suppression de la précédent image
    - docker load < lab2-alpinehelloworld.tar #chargement et décompression de l'artifact
    - docker rm -vf webapp-test || echo "container already cleaned" #suppression de précédent contenaire webapp-test
    - docker run -d -p 80:5000 -e PORT=5000 --name webapp-test lab2-alpinehelloworld #run d'un nouveau contenaire
    - sleep 5
    - apk --no-cache add curl 
    - curl "http://docker-vm" | grep  "Hello world!" #test
    - docker rm -vf webapp-test && echo "clean container"

release image:
  stage: Release image
  script: 
    - docker load < lab2-alpinehelloworld.tar
    #ajout des variable d'environnement permettant de tagger la release
    - docker tag lab2-alpinehelloworld "${IMAGE_NAME}:${CI_COMMIT_REF_NAME}"
    - docker tag lab2-alpinehelloworld "${IMAGE_NAME}:${CI_COMMIT_SHORT_SHA}"
    #configuration de login au registry gitlab
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
    - docker push "${IMAGE_NAME}:${CI_COMMIT_REF_NAME}"
    - docker push "${IMAGE_NAME}:${CI_COMMIT_SHORT_SHA}"

deploy staging:
  stage: Deploy staging
  environment:
    name: staging
    url: ${DEPLOY_LINK}  #https://webapp-staging.herokuapp.com 
  only:
    - main
  script:
    - apk --no-cache add npm
    - npm install -g heroku
    - heroku container:login
    - heroku create webapp-staging || echo "project already exit"
    - heroku container:push -a webapp-staging web
    - heroku container:release -a webapp-staging web

deploy prod:
  stage: Deploy prod
  environment:
    name: prod
    url: ${DEPLOY_LINK} #https://webapp-prod.herokuapp.com #${DEPLOY_LINK}
  only:
    - main
  script:
    - apk --no-cache add npm
    - npm install -g heroku
    - heroku container:login
    - heroku create webapp-prod || echo "project already exit"
    - heroku container:push -a webapp-prod web
    - heroku container:release -a webapp-prod web

deploy review:
  stage: Deploy review
  only:
    - merge_requests
  environment:
    name: review/$CI_COMMIT_REF_NAME
    url: ${REVIEW_LINK} #https://webapp-feature-animation-dfec8045e4cc.herokuapp.com/
    on_stop: stop review #suppression de l'environnement de review le merge validé
  script:
    - apk --no-cache add npm
    - npm install -g heroku
    - heroku container:login
    - APP_NAME=webapp-$CI_COMMIT_REF_NAME
    - "[[ ${#APP_NAME} -gt 31 ]] && echo 'the name of the heroku application you want to create is longer than 30 characters' && exit 1"
    - heroku create $APP_NAME || echo "project already exist"
    - heroku container:push -a $APP_NAME web
    - heroku container:release -a $APP_NAME web
   
stop review:
  stage: Stop review
  variables:
    GIT_STRATEGY: none
  only:
    - merge_requests
  when: manual
  environment:
    name: review/$CI_COMMIT_REF_NAME
    action: stop #ajout de l'action stop pour l'arret de l'environnement review
  script:
    - apk --no-cache add npm
    - npm install -g heroku
    - heroku container:login
    - heroku apps:destroy -a webapp-$CI_COMMIT_REF_NAME --confirm webapp-$CI_COMMIT_REF_NAME
    
